import QtQuick 2.12
import QtQuick.Controls 2.5

ApplicationWindow {
    id: window
    visible: true
    width: 1280
    height: 720
    title: qsTr("Covert Channel - Control Panel")

    header: ToolBar {
        contentHeight: 50

        ToolButton {
            id: toolButton
            text: stackView.depth > 1 ? "\u25C0" : "\u2630"
            font.pixelSize: Qt.application.font.pixelSize * 1.6
            onClicked: {
                if (stackView.depth > 1) {
                    stackView.pop()
                } else {
                    drawer.open()
                }
            }
        }

        Label {
            text: stackView.currentItem.title
            anchors.centerIn: parent
        }
    }

    Drawer {
        id: drawer
        width: window.width * 0.66
        height: 50

        Column {
            anchors.fill: parent

            ItemDelegate {
                text: qsTr("Receiving")
                width: parent.width
                onClicked: {
                    stackView.push("ReceivingForm.ui.qml")
                    drawer.close()
                }
            }
        }
    }

    StackView {
        id: stackView
        initialItem: "SendingForm.ui.qml"
        anchors.fill: parent
    }
}
